// bulletlist is used to make the clickable bullets in the statpanels
var/list/bulletlist = list()
mob
	step_size = 8
world/New()
	..()
	//populate bulletlist
	for(var/Type in typesof(/obj/sd_px_projectile))
		var/obj/O = new Type()
		bulletlist += O

// default icon and clicks for all atoms
atom
	icon = 'demo.dmi'
	Click()
		//world << "[usr] fires at [src] ([x], [y])."
		FireSpread(usr, src, usr.bullettype, usr.pellets, usr.spread)
		if(usr.secondary)
			FireSpread(usr, src, usr.secondary, usr.pellets, usr.spread)
	MouseDrag(over_object,src_location,over_location)
		// let them drag the mouse for the demo
		//world << "[usr] fires at [over_object]."
		FireSpread(usr, over_object, usr.bullettype, usr.pellets, usr.spread)
		if(usr.secondary)
			FireSpread(usr, over_object, usr.secondary, usr.pellets, usr.spread)

mob
	icon_state = "mob"
	var
		pellets = 1
		spread = 0
		obj/sd_px_projectile
			bullettype
			secondary

	Login()
		. = ..()
		world << "<B>[src] logs in."

	Logout()
		world << "<B>[src] logs out."
		del(src)

	Stat()
		stat("Pellets: [pellets]")
		stat("Spread: [spread]")
		stat("Click a weapon type to select it.")
		for(var/atom/W in bulletlist)
			if(W.type == bullettype)
				stat("1>", W)
			else if(W.type == secondary)
				stat("2>", W)
			else
				stat(W)
		stat(bulletlist.len)

	verb
		clear()
			set desc = "Clear all splatter from the world."
			for(var/atom/A)
				A.overlays = list()
		pellets(n as num)
			pellets = max(1,round(n))
		spread(n as num)
			spread = n
		say(T as text)
			world << "<b>[name]:</b> [copytext(html_encode(T),1,512)]"
		secondary()
			set desc = "Clear secondary weapon"
			secondary = null

turf/wall
	icon_state = "wall"
	density = 1

obj/sd_px_projectile
	icon_state = "proj"
	layer = 10

	Click()
		spawn(2)
			if(usr.secondary != type)
				usr.bullettype = type
				usr << "[src] selected."

	DblClick()
		usr.secondary = type
		usr << "[src] selected as secondary."


	Hit(atom/A)
		//world << "[src] hit [A] ([A.x], [A.y])."
		var/obj/O = new()
		O.icon = 'demo.dmi'
		O.icon_state = "[icon_state]_hit"
		O.layer =  A.layer + A.overlays.len/100
		O.step_x = rand(-3,3)
		O.step_y = rand(-3,3)
		A.overlays += O
		del(src)

	New()
		. = ..()
		suffix = "speed:[step_size] range:[range] delay:[delay]"


/*****************************************************************
Custom projectiles
*****************************************************************/
	longrange
		range = 50
		icon_state = "long"

	grenade
		step_x = 8
		step_y = 8
		icon_state = "ball"

		Hit(A)
			A = TurfOf(A)
			if(A) loc = A
			Terminate()	// Terminate() handles explosion

		Terminate()
			// explode in a 3x3 grid centered on loc
			var/turf/T
			var/obj/O = new()
			O.icon = 'demo.dmi'
			O.icon_state = "[icon_state]_hit"
			O.layer =  FLY_LAYER

			/* limit explosion by density
				You'll probably want a much more robust system.
				This is just a hack for this demo. */
			var/list
				L = orange(1,src)
				swapped = list()
			for(T in L)
				if(T.density)
					T.opacity = 1
					swapped += T
			T = get_step(src,dir)
			L = L - (L - view(2,T))
			for(T in swapped)
				T.opacity = 0

			for(var/atom/A in L)
				if(isarea(A) || isobj(A)) continue
				O.layer =  A.layer + A.overlays.len/100
				O.pixel_x = rand(-3,3)
				O.pixel_y = rand(-3,3)
				A.overlays += O
			del(src)

	fast
		step_size=96
		icon_state = "fast"

	slow
		step_size = 16
		range = 14
		icon_state = "slow"

	extremely_slow
		step_size = 1
		range = 80
		icon_state = "eslo"

	instant
		step_size = 100
		delay=0
		icon_state = "inst"

	fast_with_long_delay
		delay=3
		step_size=96
		icon_state = "fast"
